// (c) Copyright 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/cmf/page/ServiceHealthCheckTable","cloudera/health/HealthUtil","knockout","underscore"],function(e,t,n,r){describe("ServiceHealthCheckTable",function(){var t,i,s={id:"testTableId",urlParams:{key:"key",timestamp:1,currentMode:"true"},healthCheckTableAjaxURL:"http://localhost/healthCheckTableAjaxURL",advicePopupBaseUrl:"http://localhost/advicePopupBaseUrl"},o=e.HealthCheckGroup,u=e.HealthCheck;window.resources||(window.resources={}),window.resources.ui||(window.resources.ui={}),window.resources.ui["ui.status.badChecks"]="{0} bad.",window.resources.ui["ui.status.concerningChecks"]="{0} concerning.",window.resources.ui["ui.status.goodChecks"]="{0} good.",window.resources.ui["ui.status.unknownChecks"]="{0} unknown.",window.resources.ui["ui.status.disabledChecks"]="{0} disabled.";var a=function(){t&&t.unsubscribe()};beforeEach(function(){jasmine.Ajax.useMock(),i=$("<table></table>").attr("id",s.id).appendTo($("body")),t=new e(s)}),afterEach(function(){i.remove(),a()}),it("initializes itself on construction",function(){spyOn(n,"applyBindings"),a(),t=new e(s),expect(n.applyBindings).wasCalled(),expect(t.healthCheckGroups().length).toEqual(5),expect(t.healthIsAvailable()).toBeTruthy(),a()}),it("creates intelligent defaults for the expanded states of health check groups",function(){expect(o).toBeDefined();var e=new o("bad");expect(e.summary).toEqual("bad"),expect(e.checks().length).toEqual(0),expect(e.expanded()).toBeTruthy();var t=new o("concerning");expect(t.summary).toEqual("concerning"),expect(t.checks().length).toEqual(0),expect(t.expanded()).toBeTruthy();var n=new o("good");expect(n.summary).toEqual("good"),expect(n.checks().length).toEqual(0),expect(n.expanded()).toBeFalsy()}),it("does not let group with single check collapse",function(){expect(u).toBeDefined();var e={name:"name",description:"description",health:"good"},t=new u(e);expect(o).toBeDefined();var n=new o("good");expect(n.expanded()).toBeFalsy(),n.checks([t]),expect(n.expanded()).toBeTruthy(),n.toggleExpansion(),expect(n.expanded()).toBeTruthy()}),it("can toggle group expansion",function(){var e=new o("good");expect(e.expanded()).toBeFalsy(),e.toggleExpansion(),expect(e.expanded()).toBeTruthy()}),it("knows how to instantiate HealthChecks",function(){expect(u).toBeDefined();var e={name:"name",description:"description",health:"bad"},t=new u(e);expect(t.name).toEqual("name"),expect(t.description).toEqual("description"),expect(t.health).toEqual("bad"),expect(t.hasTimeSeriesVisualizer).toBeDefined(),expect(t.hasTimeSeriesVisualizer).toBeFalsy(),expect(t.hasHeatmapChartDescriptors).toBeDefined(),expect(t.hasHeatmapChartDescriptors).toBeFalsy()}),it("knows how to describe capabilities on health checks",function(){expect(u).toBeDefined();var e={hasTimeSeriesVisualizer:!0,hasHeatmapChartDescriptors:!0},t={name:"name",description:"description",health:"bad",caps:e},n=new u(t);expect(n.hasTimeSeriesVisualizer).toBeTruthy(),expect(n.hasHeatmapChartDescriptors).toBeTruthy()}),it("adds health check groups correctly",function(){var e={checks:n.observableArray()},r=t.healthCheckGroups().length;t.addGroupedCheck(e),expect(t.healthCheckGroups().length).toEqual(r+1)}),it("sets allExpanded if all groups are empty",function(){var e=r.all(t.healthCheckGroups(),function(e){return e.expanded()});expect(e).toBeFalsy();var n=r.all(t.healthCheckGroups(),function(e){return e.checks().length===0});expect(n).toBeTruthy(),expect(t.allExpanded()).toBeTruthy()}),it("tracks all expanded correctly when some groups have checks",function(){var e=r.all(t.healthCheckGroups(),function(e){return e.expanded()});expect(e).toBeFalsy();var n={name:"bad check",description:"bad description",health:"bad"},i=new u(n);t.onChecksChanged([i]),expect(t.allExpanded()).toBeTruthy();var s={name:"good check",description:"good description",health:"good"},o=new u(s),a=new u(s);t.onChecksChanged([i,o,a]),expect(t.allExpanded()).toBeFalsy(),t.toggleAllExpansion(),expect(t.allExpanded()).toBeTruthy()}),it("tracks each groups expansion directly",function(){var e={name:"bad check",description:"bad description",health:"bad"},n=new u(e),r=new u(e);t.onChecksChanged([n,r]),expect(t.allExpanded()).toBeTruthy();var i=t.healthCheckGroups()[0];i.toggleExpansion(),expect(t.allExpanded()).toBeFalsy()}),it("categorizes checks as they are added and maintains correct state",function(){var e=["bad","concerning","good","disabled","unknown"],n,i=function(t){var n="health_check_"+t,r="Description for health check "+t,i=e[t%e.length],s={name:n,description:r,health:i};return new u(s)},s=[];for(n=0;n<e.length;n++)s.push(i(n));var o=t.healthCheckGroups();r.each(o,function(e){expect(e.checks().length).toEqual(0)}),t.onChecksChanged(s),r.each(o,function(e){expect(e.checks().length).toEqual(1)})}),it("makes an initial server request on instantiation",function(){expect(t.madeInitialRequest).toBeTruthy()}),it("will not make a TC-based server request if the time did not change",function(){clearAjaxRequests();var e=new Date;t.updateForTimeControl(e,!1);var n=mostRecentAjaxRequest();expect(n.readyState).toEqual(2),t.updateForTimeControl(e,!1);var r=mostRecentAjaxRequest();expect(n).toEqual(r)}),it("handles responses from the server",function(){var e={data:{healthReport:{testResults:[{explanation:"Test check 1.",summary:2,testName:"someTestName"}]},statusCapabilitiesMap:{someTestName:{hasTimeSeriesVisualizer:!0,hasHeatmapChartDescriptors:!0}}}};spyOn(t,"onChecksChanged"),spyOn(t,"createHealthCheckFactory").andCallThrough(),t.handleResponseFromServer(JSON.stringify(e)),expect(t.onChecksChanged).wasCalled(),expect(t.onChecksChanged.callCount).toEqual(1);var n=t.onChecksChanged.argsForCall[0];expect(n.length).toEqual(1);var r=n[0];expect(r.length).toEqual(1);var i=r[0];expect(i.name).toEqual("someTestName"),expect(i.description).toEqual("Test check 1."),expect(i.health).toEqual("good"),expect(i.hasTimeSeriesVisualizer).toBeTruthy(),expect(i.hasHeatmapChartDescriptors).toBeTruthy()}),it("handles not available health check responses from the server",function(){var e={data:{healthReport:null}};spyOn(t,"onChecksChanged"),t.handleResponseFromServer(JSON.stringify(e)),expect(t.onChecksChanged).wasNotCalled(),expect(t.healthIsAvailable()).toBeFalsy()}),it("knows how to create a HealthCheck from the server response",function(){var e={someTestName:{hasTimeSeriesVisualizer:!0,hasHeatmapChartDescriptors:!0}},n={explanation:"Test check 1.",summary:2,testName:"someTestName"},r=t.createHealthCheckFactory(e),i=r(n);expect(i.name).toEqual(n.testName),expect(i.description).toEqual(n.explanation),expect(i.health).toEqual("good"),expect(i.hasTimeSeriesVisualizer).toEqual(e.someTestName.hasTimeSeriesVisualizer),expect(i.hasHeatmapChartDescriptors).toEqual(e.someTestName.hasHeatmapChartDescriptors),expect(i.advicePopupUrl).toBeDefined(),expect(i.advicePopupUrl.indexOf("http://localhost/advicePopupBaseUrl?")===0).toBeTruthy()})})})